'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.toast = exports.ToastContainer = exports.StateHOF = exports.setAccessToken = exports.Label = exports.withOptionItems = exports.EmailPasswordLogin = exports.CodeLogin = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

require('babel-polyfill/dist/polyfill');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRedux = require('react-redux');

var _StateHOF = require('./StateHOF');

var _StateHOF2 = _interopRequireDefault(_StateHOF);

var _reactRouterDom = require('react-router-dom');

var _CreateOrReadOne = require('./AppLib/CreateOrReadOne');

var _CreateOrReadOne2 = _interopRequireDefault(_CreateOrReadOne);

var _ReadMany = require('./AppLib/ReadMany');

var _ReadMany2 = _interopRequireDefault(_ReadMany);

var _Update = require('./AppLib/Update');

var _Update2 = _interopRequireDefault(_Update);

var _IndexRoute = require('./AppLib/IndexRoute');

var _IndexRoute2 = _interopRequireDefault(_IndexRoute);

var _NavBar = require('./AppLib/NavBar');

var _NavBar2 = _interopRequireDefault(_NavBar);

var _CodeLogin = require('./AppLib/LoginLib/CodeLogin');

var _CodeLogin2 = _interopRequireDefault(_CodeLogin);

var _EmailPasswordLogin = require('./AppLib/LoginLib/EmailPasswordLogin');

var _EmailPasswordLogin2 = _interopRequireDefault(_EmailPasswordLogin);

var _withOptionItems = require('./AppLib/formLib/withOptionItems');

var _withOptionItems2 = _interopRequireDefault(_withOptionItems);

var _Label = require('./AppLib/formLib/Label');

var _Label2 = _interopRequireDefault(_Label);

var _reactToastify = require('react-toastify');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var App = function (_Component) {
  _inherits(App, _Component);

  function App() {
    _classCallCheck(this, App);

    return _possibleConstructorReturn(this, (App.__proto__ || Object.getPrototypeOf(App)).apply(this, arguments));
  }

  _createClass(App, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      document.title = this.props.config.title || 'CMS';
    }
  }, {
    key: 'render',
    value: function render() {
      var config = this.props.config;

      var resourceRouteElements = config.resources.reduce(function (acc, resource) {
        var uniqKey = resource.uniqKey;
        var _resource$crudMapping = resource.crudMapping,
            create = _resource$crudMapping.create,
            readMany = _resource$crudMapping.readMany,
            readOne = _resource$crudMapping.readOne,
            update = _resource$crudMapping.update;


        var resourceName = resource.displayName || resource.name;

        if (readMany) {
          var path = '/' + resourceName;
          acc.push(_react2.default.createElement(_reactRouterDom.Route, {
            key: path,
            exact: true,
            path: path,
            render: function render(props) {
              return _react2.default.createElement(_ReadMany2.default, _extends({ resource: resource, config: config }, props));
            }
          }));
        }
        if (create || readOne) {
          var _path = '/' + resourceName + '/:' + uniqKey;
          acc.push(_react2.default.createElement(_reactRouterDom.Route, {
            key: _path,
            exact: true,
            path: _path,
            render: function render(props) {
              return _react2.default.createElement(_CreateOrReadOne2.default, _extends({ resource: resource, config: config }, props));
            }
          }));
        }
        if (update) {
          var _path2 = '/' + resourceName + '/:' + uniqKey + '/edit';
          acc.push(_react2.default.createElement(_reactRouterDom.Route, {
            key: _path2,
            exact: true,
            path: _path2,
            render: function render(props) {
              return _react2.default.createElement(_Update2.default, _extends({ resource: resource, config: config }, props));
            }
          }));
        }
        return acc;
      }, []);

      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(
          _reactRouterDom.BrowserRouter,
          null,
          _react2.default.createElement(
            'div',
            null,
            _react2.default.createElement(_NavBar2.default, { config: config }),
            _react2.default.createElement(
              'div',
              { className: 'container-fluid' },
              _react2.default.createElement(_reactRouterDom.Route, { render: function render(props) {
                  return _react2.default.createElement(_IndexRoute2.default, _extends({}, props, { config: config }));
                } }),
              resourceRouteElements
            )
          )
        )
      );
    }
  }]);

  return App;
}(_react.Component);

function DefaultLogin() {
  return _react2.default.createElement(
    'div',
    null,
    _react2.default.createElement(
      'h1',
      null,
      'You need to provide a React Component to the "Login" option'
    )
  );
}

function AppWithGuard(props) {
  var config = props.config;

  var Login = config.Login || DefaultLogin;

  var ComponentWithGuard = function ComponentWithGuard(props) {
    if (props.accessToken) {
      return _react2.default.createElement(App, props);
    } else {
      return Login ? _react2.default.createElement(Login, props) : null;
    }
  };

  var ComponentWithState = (0, _reactRedux.connect)(function (state) {
    return { accessToken: state.accessToken };
  }, { setAccessToken: _StateHOF.setAccessToken })(ComponentWithGuard);

  return _react2.default.createElement(ComponentWithState, props);
}

function AppWithToast(props) {
  return _react2.default.createElement(
    'div',
    null,
    _react2.default.createElement(_reactToastify.ToastContainer, {
      position: 'top-center',
      type: 'default',
      autoClose: 5000,
      hideProgressBar: false,
      newestOnTop: false,
      closeOnClick: true,
      pauseOnHover: true
    }),
    _react2.default.createElement(AppWithGuard, props)
  );
}

exports.default = (0, _StateHOF2.default)(AppWithToast);
exports.CodeLogin = _CodeLogin2.default;
exports.EmailPasswordLogin = _EmailPasswordLogin2.default;
exports.withOptionItems = _withOptionItems2.default;
exports.Label = _Label2.default;
exports.setAccessToken = _StateHOF.setAccessToken;
exports.StateHOF = _StateHOF2.default;
exports.ToastContainer = _reactToastify.ToastContainer;
exports.toast = _reactToastify.toast;