'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _templateObject = _taggedTemplateLiteral(['\n  mutation ', '($input: ', '!) {\n    ', '(', ' : $input)\n  }\n  '], ['\n  mutation ', '($input: ', '!) {\n    ', '(', ' : $input)\n  }\n  ']);

var _lodash = require('lodash');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactApollo = require('react-apollo');

var _reactToastify = require('react-toastify');

var _Form = require('./Form');

var _Form2 = _interopRequireDefault(_Form);

var _getCRUDSchemaFromResource = require('../GqlCmsConfigLib/getCRUDSchemaFromResource');

var _getCRUDSchemaFromResource2 = _interopRequireDefault(_getCRUDSchemaFromResource);

var _alertFirstGqlMsg = require('../alertFirstGqlMsg');

var _alertFirstGqlMsg2 = _interopRequireDefault(_alertFirstGqlMsg);

var _undefinedToNull = require('../formLib/undefinedToNull');

var _undefinedToNull2 = _interopRequireDefault(_undefinedToNull);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function Create(props) {
  var _this = this;

  var resource = props.resource,
      mutate = props.mutate,
      config = props.config,
      history = props.history;


  var resourceName = resource.displayName || resource.name;

  var onSubmit = function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(_ref2) {
      var formData = _ref2.formData;
      var input;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              input = (0, _undefinedToNull2.default)(formData);
              _context.prev = 1;
              _context.next = 4;
              return mutate({ variables: { input: input } });

            case 4:
              history.push('/' + resourceName);
              _reactToastify.toast.success('Create Success');
              _context.next = 11;
              break;

            case 8:
              _context.prev = 8;
              _context.t0 = _context['catch'](1);

              (0, _alertFirstGqlMsg2.default)(_context.t0);

            case 11:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, _this, [[1, 8]]);
    }));

    return function onSubmit(_x) {
      return _ref.apply(this, arguments);
    };
  }();
  var onCancel = function onCancel() {
    history.push('/' + resourceName);
  };
  var createSchema = (0, _getCRUDSchemaFromResource2.default)({
    config: config,
    resource: resource,
    crudType: 'create'
  });
  return _react2.default.createElement(
    'div',
    null,
    _react2.default.createElement(
      'h1',
      null,
      'Create ',
      (0, _lodash.startCase)(resourceName)
    ),
    _react2.default.createElement(_Form2.default, {
      jsonSchemaFormExtensions: config.jsonSchemaFormExtensions,
      schema: createSchema.jsonSchema,
      uiSchema: createSchema.uiSchema,
      noHtml5Validate: true,
      onSubmit: onSubmit,
      onCancel: onCancel
    })
  );
}

function CreateWithData(props) {
  var resource = props.resource;
  var crudMapping = resource.crudMapping;

  var Component = Create;
  var CreateQuery = (0, _reactApollo.gql)(_templateObject, crudMapping.create, (0, _lodash.upperFirst)(resource.name + 'Input'), crudMapping.create, resource.name);
  Component = (0, _reactApollo.graphql)(CreateQuery)(Component);

  return _react2.default.createElement(Component, props);
}

exports.default = CreateWithData;