'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };
// NOTE: TitleField is used for ArrayField


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactJsonschemaForm = require('react-jsonschema-form');

var _reactJsonschemaForm2 = _interopRequireDefault(_reactJsonschemaForm);

var _HasOneWidget = require('./formLib/HasOneWidget');

var _HasOneWidget2 = _interopRequireDefault(_HasOneWidget);

var _WysiwygWidget = require('./formLib/WysiwygWidget');

var _WysiwygWidget2 = _interopRequireDefault(_WysiwygWidget);

var _HasManyField = require('./formLib/HasManyField');

var _HasManyField2 = _interopRequireDefault(_HasManyField);

var _FieldTemplate = require('./formLib/FieldTemplate');

var _FieldTemplate2 = _interopRequireDefault(_FieldTemplate);

var _TitleField = require('./formLib/TitleField');

var _TitleField2 = _interopRequireDefault(_TitleField);

var _CurrencyWidget = require('./formLib/CurrencyWidget');

var _CurrencyWidget2 = _interopRequireDefault(_CurrencyWidget);

var _NumberWidget = require('./formLib/NumberWidget');

var _NumberWidget2 = _interopRequireDefault(_NumberWidget);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function FormButtons(props) {
  var onCancel = props.onCancel,
      readOnly = props.readOnly;


  if (readOnly) {
    return _react2.default.createElement(
      'div',
      null,
      _react2.default.createElement(
        'button',
        { type: 'button', className: 'btn btn-primary', onClick: onCancel },
        'Back'
      ),
      _react2.default.createElement(
        'button',
        { type: 'submit', style: { display: 'none' } },
        'Submit'
      )
    );
  }

  return _react2.default.createElement(
    'div',
    null,
    _react2.default.createElement(
      'button',
      { type: 'button', className: 'btn btn-danger', onClick: onCancel },
      'Cancel'
    ),
    _react2.default.createElement(
      'button',
      { type: 'submit', className: 'btn btn-primary', style: { float: 'right' } },
      'Submit'
    )
  );
}

var defaultWidgets = {
  currencyWidget: _CurrencyWidget2.default,
  hasOneWidget: _HasOneWidget2.default,
  numberWidget: _NumberWidget2.default,
  wysiwygWidget: _WysiwygWidget2.default
};

var defaultFields = {
  hasManyField: _HasManyField2.default,
  TitleField: _TitleField2.default
};

function ExtendedForm(props) {
  var jsonSchemaFormExtensions = props.jsonSchemaFormExtensions || {};
  var _jsonSchemaFormExtens = jsonSchemaFormExtensions.widgets,
      widgets = _jsonSchemaFormExtens === undefined ? {} : _jsonSchemaFormExtens,
      _jsonSchemaFormExtens2 = jsonSchemaFormExtensions.fields,
      fields = _jsonSchemaFormExtens2 === undefined ? {} : _jsonSchemaFormExtens2;


  return _react2.default.createElement(
    _reactJsonschemaForm2.default,
    _extends({
      FieldTemplate: _FieldTemplate2.default,
      widgets: _extends({}, defaultWidgets, widgets),
      fields: _extends({}, defaultFields, fields)
    }, props),
    _react2.default.createElement(FormButtons, {
      onCancel: props.onCancel,
      readOnly: props.readOnly
    })
  );
}

exports.default = ExtendedForm;