'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRouterDom = require('react-router-dom');

var _lodash = require('lodash');

var _pluralize = require('pluralize');

var _pluralize2 = _interopRequireDefault(_pluralize);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function IndexRoute(props) {
  var config = props.config,
      history = props.history;

  if (history.location.pathname === '/' && config.initialPath) {
    return _react2.default.createElement(_reactRouterDom.Redirect, { to: config.initialPath });
  }

  var indexRouteElement = _react2.default.createElement(_reactRouterDom.Route, {
    exact: true,
    path: '/',
    render: function render() {
      var resourceLinks = config.resources.reduce(function (acc, resource) {
        if (resource.crudMapping.readMany) {
          var resourceName = resource.displayName || resource.name;

          acc.push(_react2.default.createElement(
            'tr',
            { key: resourceName },
            _react2.default.createElement(
              'td',
              null,
              _react2.default.createElement(
                _reactRouterDom.Link,
                { to: '/' + resourceName },
                (0, _lodash.startCase)((0, _pluralize2.default)(resourceName))
              )
            )
          ));
        }
        return acc;
      }, []);

      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(
          'h1',
          null,
          'Site Administration'
        ),
        _react2.default.createElement(
          'table',
          { className: 'table table-striped' },
          _react2.default.createElement(
            'tbody',
            null,
            resourceLinks
          )
        )
      );
    }
  });

  return indexRouteElement;
}

exports.default = IndexRoute;