'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _templateObject = _taggedTemplateLiteral(['\n  mutation LoginMutation($loginInput: LoginInput!) {\n    login(loginInput: $loginInput)\n  }\n'], ['\n  mutation LoginMutation($loginInput: LoginInput!) {\n    login(loginInput: $loginInput)\n  }\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactApollo = require('react-apollo');

var _alertFirstGqlMsg = require('../../alertFirstGqlMsg');

var _alertFirstGqlMsg2 = _interopRequireDefault(_alertFirstGqlMsg);

var _StateHOF = require('../../StateHOF');

var _reactRedux = require('react-redux');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var LoginMutation = (0, _reactApollo.gql)(_templateObject);

var Login = function (_React$Component) {
  _inherits(Login, _React$Component);

  function Login(props) {
    _classCallCheck(this, Login);

    var _this = _possibleConstructorReturn(this, (Login.__proto__ || Object.getPrototypeOf(Login)).call(this, props));

    _this.state = {
      email: '',
      password: '',
      loggingIn: false
    };
    return _this;
  }

  _createClass(Login, [{
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.setState({ loggingIn: false });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var onSubmit = function () {
        var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(e) {
          var response, token;
          return regeneratorRuntime.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  e.preventDefault();

                  _this2.setState({ loggingIn: true });

                  _context.prev = 2;
                  _context.next = 5;
                  return _this2.props.mutate({
                    variables: {
                      loginInput: {
                        email: _this2.state.email,
                        password: _this2.state.password
                      }
                    }
                  });

                case 5:
                  response = _context.sent;
                  token = response.data.login;

                  _this2.props.setAccessToken(token);
                  _context.next = 13;
                  break;

                case 10:
                  _context.prev = 10;
                  _context.t0 = _context['catch'](2);

                  _this2.setState({ loggingIn: false }, function () {
                    (0, _alertFirstGqlMsg2.default)(_context.t0);
                  });

                case 13:
                case 'end':
                  return _context.stop();
              }
            }
          }, _callee, _this2, [[2, 10]]);
        }));

        return function onSubmit(_x) {
          return _ref.apply(this, arguments);
        };
      }();

      var containerStyle = {
        display: 'flex',
        flexDirection: 'column',
        justifyContent: 'center',
        alignItems: 'center'
      };
      var formStyle = {
        width: '300px',
        maxWidth: '100%'
      };
      var h1Style = {
        marginBottom: '20px'
      };
      var buttonStyle = {
        width: '100%'
      };

      var _state = this.state,
          email = _state.email,
          password = _state.password,
          loggingIn = _state.loggingIn;


      return _react2.default.createElement(
        'div',
        { style: containerStyle },
        _react2.default.createElement(
          'h1',
          { style: h1Style },
          'Login'
        ),
        _react2.default.createElement(
          'form',
          { onSubmit: onSubmit, style: formStyle },
          _react2.default.createElement('input', {
            className: 'form-control',
            placeholder: 'Email',
            type: 'email',
            value: email,
            onChange: function onChange(e) {
              return _this2.setState({ email: e.target.value });
            }
          }),
          _react2.default.createElement('br', null),
          _react2.default.createElement('input', {
            className: 'form-control',
            placeholder: 'Password',
            type: 'password',
            value: password,
            onChange: function onChange(e) {
              return _this2.setState({ password: e.target.value });
            }
          }),
          _react2.default.createElement('br', null),
          _react2.default.createElement(
            'button',
            {
              className: 'btn btn-primary',
              type: 'submit',
              style: buttonStyle,
              disabled: loggingIn
            },
            loggingIn ? 'Logging in...' : 'Login'
          )
        )
      );
    }
  }]);

  return Login;
}(_react2.default.Component);

var LoginFormWithData = (0, _reactApollo.graphql)(LoginMutation)(Login);

var LoginFormWithState = (0, _reactRedux.connect)(function (state) {
  return { accessToken: state.accessToken };
}, { setAccessToken: _StateHOF.setAccessToken })(LoginFormWithData);

exports.default = LoginFormWithState;