'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRouterDom = require('react-router-dom');

var _reactRedux = require('react-redux');

var _StateHOF = require('../StateHOF');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function NavBar(props) {
  var accessToken = props.accessToken,
      setAccessToken = props.setAccessToken,
      config = props.config;

  var brand = config.brand || 'CMS';

  function handleClick() {
    setAccessToken(null);
    window.location = '/';
  }

  return _react2.default.createElement(
    'nav',
    { className: 'navbar navbar-default' },
    _react2.default.createElement(
      'div',
      { className: 'container-fluid' },
      _react2.default.createElement(
        'div',
        { className: 'navbar-header' },
        _react2.default.createElement(
          _reactRouterDom.Link,
          {
            className: 'navbar-brand',
            to: '/'
          },
          brand
        )
      ),
      _react2.default.createElement(
        'ul',
        { className: 'nav navbar-nav navbar-right' },
        _react2.default.createElement(
          'li',
          null,
          accessToken ? _react2.default.createElement(
            'a',
            { style: { cursor: 'pointer' }, onClick: handleClick },
            'Logout'
          ) : null
        )
      )
    )
  );
}

var NavBarWithState = (0, _reactRedux.connect)(function (state) {
  return { accessToken: state.accessToken };
}, { setAccessToken: _StateHOF.setAccessToken })(NavBar);

exports.default = NavBarWithState;