'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _templateObject = _taggedTemplateLiteral(['\n  query ', ' {\n    ', ' ', ' {\n      items ', '\n      total\n    }\n  }\n  '], ['\n  query ', ' {\n    ', ' ', ' {\n      items ', '\n      total\n    }\n  }\n  ']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _qs = require('qs');

var _qs2 = _interopRequireDefault(_qs);

var _reactApollo = require('react-apollo');

var _reactRouterDom = require('react-router-dom');

var _lodash = require('lodash');

var _pluralize = require('pluralize');

var _pluralize2 = _interopRequireDefault(_pluralize);

var _jsonSchemaToGqlQuery = require('../GqlCmsConfigLib/jsonSchemaToGqlQuery');

var _jsonSchemaToGqlQuery2 = _interopRequireDefault(_jsonSchemaToGqlQuery);

var _getCRUDSchemaFromResource = require('../GqlCmsConfigLib/getCRUDSchemaFromResource');

var _getCRUDSchemaFromResource2 = _interopRequireDefault(_getCRUDSchemaFromResource);

var _ensureUniqKey = require('../GqlCmsConfigLib/ensureUniqKey');

var _ensureUniqKey2 = _interopRequireDefault(_ensureUniqKey);

var _getReadManyInputQueryString = require('./ReadManyLib/getReadManyInputQueryString');

var _getReadManyInputQueryString2 = _interopRequireDefault(_getReadManyInputQueryString);

var _defaultCellFormatter = require('./ReadManyLib/defaultCellFormatter');

var _defaultCellFormatter2 = _interopRequireDefault(_defaultCellFormatter);

var _Tr = require('./ReadManyLib/Tr');

var _Tr2 = _interopRequireDefault(_Tr);

var _Paginate = require('./ReadManyLib/Paginate');

var _Paginate2 = _interopRequireDefault(_Paginate);

var _Search = require('./ReadManyLib/Search');

var _Search2 = _interopRequireDefault(_Search);

var _ThField = require('./ReadManyLib/ThField');

var _ThField2 = _interopRequireDefault(_ThField);

var _alertFirstGqlMsg = require('../alertFirstGqlMsg');

var _alertFirstGqlMsg2 = _interopRequireDefault(_alertFirstGqlMsg);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DEFAULT_ITEMS_PER_PAGE = 15;

var ReadMany = function (_React$Component) {
  _inherits(ReadMany, _React$Component);

  function ReadMany(props) {
    _classCallCheck(this, ReadMany);

    // NOTE: loading is not used in render, we may need it later on
    var _this = _possibleConstructorReturn(this, (ReadMany.__proto__ || Object.getPrototypeOf(ReadMany)).call(this, props));

    _this.state = {
      loading: true,
      items: [],
      total: 0
    };
    return _this;
  }

  _createClass(ReadMany, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.fetchReadMany(this.props);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      this.fetchReadMany(nextProps);
    }
  }, {
    key: 'changeUrl',
    value: function changeUrl(paramsOverride) {
      var _props = this.props,
          history = _props.history,
          location = _props.location,
          queryParams = _props.queryParams;

      var _queryParams$skip$par = _extends({}, queryParams, { skip: 0 }, paramsOverride),
          skip = _queryParams$skip$par.skip,
          limit = _queryParams$skip$par.limit,
          search = _queryParams$skip$par.search,
          sort = _queryParams$skip$par.sort;

      var queryParmasString = _qs2.default.stringify({
        skip: skip,
        limit: limit,
        search: search,
        sort: sort
      });
      history.push([location.pathname, queryParmasString].join('?'));
    }
  }, {
    key: 'fetchReadMany',
    value: function fetchReadMany(props) {
      var _this2 = this;

      var readManySchema = props.readManySchema,
          resource = props.resource,
          client = props.client;
      var uniqKey = resource.uniqKey,
          crudMapping = resource.crudMapping;

      var fieldsQuery = (0, _jsonSchemaToGqlQuery2.default)((0, _ensureUniqKey2.default)(readManySchema.jsonSchema, uniqKey));

      var _props$queryParams = props.queryParams,
          limit = _props$queryParams.limit,
          sort = _props$queryParams.sort,
          search = _props$queryParams.search,
          skip = _props$queryParams.skip;


      var ReadManyInputQueryString = (0, _getReadManyInputQueryString2.default)(readManySchema, { skip: skip, limit: limit, sort: sort, search: search });
      var ReadManyQuery = (0, _reactApollo.gql)(_templateObject, crudMapping.readMany, crudMapping.readMany, ReadManyInputQueryString, fieldsQuery);
      this.setState({ loading: true });
      client.query({ query: ReadManyQuery, fetchPolicy: 'network-only' }).then(function (_ref) {
        var data = _ref.data;
        var _data$resource$crudMa = data[resource.crudMapping.readMany],
            items = _data$resource$crudMa.items,
            total = _data$resource$crudMa.total;

        _this2.setState({
          loading: false,
          items: items,
          total: total
        });
      }).catch(function (e) {
        (0, _alertFirstGqlMsg2.default)(e);

        throw e;
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var _state = this.state,
          items = _state.items,
          total = _state.total;
      var _props2 = this.props,
          _props2$queryParams = _props2.queryParams,
          skip = _props2$queryParams.skip,
          limit = _props2$queryParams.limit,
          sort = _props2$queryParams.sort,
          search = _props2$queryParams.search,
          mutate = _props2.client.mutate,
          resource = _props2.resource,
          readManySchema = _props2.readManySchema;
      var properties = readManySchema.jsonSchema.properties;

      var columnNames = Object.keys(properties);

      var thActionsElement = _react2.default.createElement(
        'th',
        { style: { textAlign: 'right' }, key: 'actions' },
        'Actions'
      );
      var thFieldElements = columnNames.map(function (columnName) {
        var title = properties[columnName].title;


        return _react2.default.createElement(_ThField2.default, {
          key: columnName,
          columnName: title || columnName,
          readManySchema: readManySchema,
          sort: sort,
          onSortChange: function onSortChange(nextSort) {
            _this3.changeUrl({ sort: nextSort });
          }
        });
      });
      var thElements = thFieldElements.concat(thActionsElement);

      var cellFormatter = readManySchema.cellFormatter || _defaultCellFormatter2.default;
      var trElements = items.map(function (row, index) {
        return _react2.default.createElement(_Tr2.default, {
          key: index,
          row: row,
          resource: resource,
          cellFormatter: cellFormatter,
          mutate: mutate,
          changeUrl: function changeUrl(paramsOverride) {
            return _this3.changeUrl(paramsOverride);
          },
          columnNames: columnNames
        });
      });

      var resourceName = resource.displayName || resource.name;

      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(
          'h1',
          null,
          'List of ',
          (0, _lodash.startCase)((0, _pluralize2.default)(resourceName)),
          readManySchema.showTotal ? ' (total: ' + total + ')' : null,
          resource.crudMapping.create ? _react2.default.createElement(
            _reactRouterDom.Link,
            {
              style: { float: 'right' },
              className: 'btn btn-primary btn-outline',
              to: '/' + resourceName + '/new'
            },
            'Add New'
          ) : null
        ),
        readManySchema.searchStrategy ? _react2.default.createElement(_Search2.default, {
          search: search,
          onSearchChange: function onSearchChange(nextSearch) {
            return _this3.changeUrl({ search: nextSearch });
          }
        }) : null,
        _react2.default.createElement(
          'div',
          { style: { overflowX: 'scroll' } },
          _react2.default.createElement(
            'table',
            { className: 'table table-striped' },
            _react2.default.createElement(
              'thead',
              null,
              _react2.default.createElement(
                'tr',
                null,
                thElements
              )
            ),
            _react2.default.createElement(
              'tbody',
              null,
              trElements
            )
          ),
          readManySchema.paginationStrategy ? _react2.default.createElement(_Paginate2.default, {
            limit: limit,
            total: total,
            skip: skip,
            onSkipChange: function onSkipChange(nextSkip) {
              return _this3.changeUrl({ skip: nextSkip });
            }
          }) : null
        )
      );
    }
  }]);

  return ReadMany;
}(_react2.default.Component);

var ReadManyWithApollo = (0, _reactApollo.withApollo)(ReadMany);

function ReadManyWithData(props) {
  var config = props.config,
      resource = props.resource,
      location = props.location;


  var readManySchema = (0, _getCRUDSchemaFromResource2.default)({
    config: config,
    resource: resource,
    crudType: 'readMany'
  });

  var search = location.search;

  var limit = (0, _lodash.get)(readManySchema, 'paginationStrategy.itemsPerPage', DEFAULT_ITEMS_PER_PAGE);
  var defaultQueryParams = { limit: limit, skip: 0, sort: [], search: '' };
  var overrideQueryParams = search ? _qs2.default.parse(search.substring(1)) : {};
  var queryParams = _extends({}, defaultQueryParams, overrideQueryParams);

  return _react2.default.createElement(ReadManyWithApollo, _extends({}, props, {
    queryParams: queryParams,
    readManySchema: readManySchema
  }));
}

exports.default = ReadManyWithData;