'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactPaginate = require('react-paginate');

var _reactPaginate2 = _interopRequireDefault(_reactPaginate);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function Paginate(_ref) {
  var skip = _ref.skip,
      limit = _ref.limit,
      total = _ref.total,
      onSkipChange = _ref.onSkipChange;

  var pageCount = Math.ceil(total / limit);
  var forcePage = Math.ceil(skip / limit);
  return _react2.default.createElement(_reactPaginate2.default, {
    activeClassName: 'active',
    containerClassName: 'pagination',
    forcePage: forcePage,
    onPageChange: function onPageChange(_ref2) {
      var selected = _ref2.selected;
      return onSkipChange(limit * selected);
    },
    pageCount: pageCount,
    pageRangeDisplayed: 5,
    marginPagesDisplayed: 3
  });
}

exports.default = Paginate;