'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRouterDom = require('react-router-dom');

var _lodash = require('lodash');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function TdAction(_ref) {
  var resource = _ref.resource,
      row = _ref.row,
      handleDelete = _ref.handleDelete;

  var resourceName = resource.displayName || resource.name;

  return _react2.default.createElement(
    'td',
    { style: { textAlign: 'right' } },
    resource.crudMapping.update ? _react2.default.createElement(
      _reactRouterDom.Link,
      {
        className: 'btn btn-sm btn-primary',
        to: '/' + resourceName + '/' + row[resource.uniqKey] + '/edit'
      },
      'Edit'
    ) : null,
    resource.crudMapping.delete ? _react2.default.createElement(
      'button',
      {
        className: 'btn btn-sm btn-danger',
        onClick: handleDelete
      },
      'Delete'
    ) : null,
    resource.crudMapping.readOne && (0, _lodash.get)(resource, 'readOneSchema.show') ? _react2.default.createElement(
      _reactRouterDom.Link,
      {
        className: 'btn btn-sm btn-info',
        to: '/' + resourceName + '/' + row[resource.uniqKey]
      },
      'View'
    ) : null
  );
}

exports.default = TdAction;