'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _templateObject = _taggedTemplateLiteral(['\n      mutation ', '($', ': String!) {\n        ', '(', ': $', ')\n      }\n    '], ['\n      mutation ', '($', ': String!) {\n        ', '(', ': $', ')\n      }\n    ']);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactApollo = require('react-apollo');

var _reactToastify = require('react-toastify');

var _TdAction = require('./TdAction');

var _TdAction2 = _interopRequireDefault(_TdAction);

var _alertFirstGqlMsg = require('../../alertFirstGqlMsg');

var _alertFirstGqlMsg2 = _interopRequireDefault(_alertFirstGqlMsg);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function Tr(props) {
  var _this = this;

  var row = props.row,
      resource = props.resource,
      cellFormatter = props.cellFormatter,
      mutate = props.mutate,
      changeUrl = props.changeUrl,
      columnNames = props.columnNames;


  var handleDelete = function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
      var confirm, crudMapping, uniqKey, uniqKeyQuery, deleteMutation;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              // eslint-disable-next-line no-alert
              confirm = window.confirm('Are you sure you want to delete?');

              if (confirm) {
                _context.next = 3;
                break;
              }

              return _context.abrupt('return');

            case 3:
              crudMapping = resource.crudMapping, uniqKey = resource.uniqKey;
              uniqKeyQuery = _defineProperty({}, uniqKey, row[uniqKey]);
              deleteMutation = (0, _reactApollo.gql)(_templateObject, crudMapping.delete, uniqKey, crudMapping.delete, uniqKey, uniqKey);
              _context.prev = 6;
              _context.next = 9;
              return mutate({
                mutation: deleteMutation,
                variables: uniqKeyQuery
              });

            case 9:

              changeUrl();
              _reactToastify.toast.success('Delete Success');
              _context.next = 16;
              break;

            case 13:
              _context.prev = 13;
              _context.t0 = _context['catch'](6);

              (0, _alertFirstGqlMsg2.default)(_context.t0);

            case 16:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, _this, [[6, 13]]);
    }));

    return function handleDelete() {
      return _ref.apply(this, arguments);
    };
  }();

  var tdFieldElements = columnNames.map(function (columnName) {
    return _react2.default.createElement(
      'td',
      { key: columnName },
      cellFormatter(row[columnName], row, columnName)
    );
  });

  return _react2.default.createElement(
    'tr',
    null,
    tdFieldElements,
    _react2.default.createElement(_TdAction2.default, {
      key: 'actions',
      resource: resource,
      row: row,
      handleDelete: handleDelete
    })
  );
}

Tr.propTypes = {
  row: _propTypes2.default.object.isRequired,
  resource: _propTypes2.default.object.isRequired,
  cellFormatter: _propTypes2.default.func.isRequired,
  mutate: _propTypes2.default.func.isRequired,
  changeUrl: _propTypes2.default.func.isRequired,
  columnNames: _propTypes2.default.arrayOf(_propTypes2.default.string).isRequired
};

exports.default = Tr;