'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _templateObject = _taggedTemplateLiteral(['\n  query ', '($', ': String!) {\n    ', '(', ': $', ') ', '\n  }\n  '], ['\n  query ', '($', ': String!) {\n    ', '(', ': $', ') ', '\n  }\n  ']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactApollo = require('react-apollo');

var _Form = require('./Form');

var _Form2 = _interopRequireDefault(_Form);

var _jsonSchemaToGqlQuery = require('../GqlCmsConfigLib/jsonSchemaToGqlQuery');

var _jsonSchemaToGqlQuery2 = _interopRequireDefault(_jsonSchemaToGqlQuery);

var _getCRUDSchemaFromResource = require('../GqlCmsConfigLib/getCRUDSchemaFromResource');

var _getCRUDSchemaFromResource2 = _interopRequireDefault(_getCRUDSchemaFromResource);

var _removeTypename = require('../removeTypename');

var _removeTypename2 = _interopRequireDefault(_removeTypename);

var _graphqlWithoutCache = require('../graphqlWithoutCache');

var _graphqlWithoutCache2 = _interopRequireDefault(_graphqlWithoutCache);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

function ReadOne(props) {
  var config = props.config,
      resource = props.resource,
      data = props.data,
      history = props.history;

  var purifiedFormData = (0, _removeTypename2.default)(data[resource.crudMapping.readOne]);
  if (data.loading) {
    return null;
  }

  var resourceName = resource.displayName || resource.name;

  var onCancel = function onCancel() {
    history.push('/' + resourceName);
  };
  var readOneSchema = (0, _getCRUDSchemaFromResource2.default)({
    config: config,
    resource: resource,
    crudType: 'readOne'
  });
  var uiSchema = _extends({
    'ui:disabled': true
  }, readOneSchema.uiSchema);
  return _react2.default.createElement(
    'div',
    null,
    _react2.default.createElement(_Form2.default, {
      jsonSchemaFormExtensions: config.jsonSchemaFormExtensions,
      schema: readOneSchema.jsonSchema,
      uiSchema: uiSchema,
      formData: purifiedFormData,
      onCancel: onCancel,
      noHtml5Validate: true,
      readOnly: true
    })
  );
}

function ReadOneWithData(props) {
  var config = props.config,
      resource = props.resource;
  var crudMapping = resource.crudMapping,
      uniqKey = resource.uniqKey;

  var readOneSchema = (0, _getCRUDSchemaFromResource2.default)({
    config: config,
    resource: resource,
    crudType: 'readOne'
  });

  var Component = ReadOne;
  var fieldsQuery = (0, _jsonSchemaToGqlQuery2.default)(readOneSchema.jsonSchema);
  var ReadOneQuery = (0, _reactApollo.gql)(_templateObject, crudMapping.readOne, uniqKey, crudMapping.readOne, uniqKey, uniqKey, fieldsQuery);
  var uniqKeyValue = props.match.params[uniqKey];
  Component = (0, _graphqlWithoutCache2.default)(ReadOneQuery, { options: { variables: _defineProperty({}, uniqKey, uniqKeyValue) } })(Component);

  return _react2.default.createElement(Component, props);
}

exports.default = ReadOneWithData;