'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _templateObject = _taggedTemplateLiteral(['\n  query ', '($', ': String!) {\n    ', '(', ': $', ') ', '\n  }\n  '], ['\n  query ', '($', ': String!) {\n    ', '(', ': $', ') ', '\n  }\n  ']),
    _templateObject2 = _taggedTemplateLiteral(['\n  mutation ', '($input: ', '!) {\n    ', '(', ' : $input, ', ': "', '")\n  }\n  '], ['\n  mutation ', '($input: ', '!) {\n    ', '(', ' : $input, ', ': "', '")\n  }\n  ']);

var _lodash = require('lodash');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactApollo = require('react-apollo');

var _reactToastify = require('react-toastify');

var _graphqlWithoutCache = require('../graphqlWithoutCache');

var _graphqlWithoutCache2 = _interopRequireDefault(_graphqlWithoutCache);

var _Form = require('./Form');

var _Form2 = _interopRequireDefault(_Form);

var _jsonSchemaToGqlQuery = require('../GqlCmsConfigLib/jsonSchemaToGqlQuery');

var _jsonSchemaToGqlQuery2 = _interopRequireDefault(_jsonSchemaToGqlQuery);

var _getCRUDSchemaFromResource = require('../GqlCmsConfigLib/getCRUDSchemaFromResource');

var _getCRUDSchemaFromResource2 = _interopRequireDefault(_getCRUDSchemaFromResource);

var _removeTypename = require('../removeTypename');

var _removeTypename2 = _interopRequireDefault(_removeTypename);

var _nullToUndefined = require('../formLib/nullToUndefined');

var _nullToUndefined2 = _interopRequireDefault(_nullToUndefined);

var _undefinedToNull = require('../formLib/undefinedToNull');

var _undefinedToNull2 = _interopRequireDefault(_undefinedToNull);

var _alertFirstGqlMsg = require('../alertFirstGqlMsg');

var _alertFirstGqlMsg2 = _interopRequireDefault(_alertFirstGqlMsg);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function Update(props) {
  var _this = this;

  var config = props.config,
      resource = props.resource,
      mutate = props.mutate,
      data = props.data,
      history = props.history;

  var dirtyFormData = data[resource.crudMapping.readOne];
  var purifiedFormData = (0, _nullToUndefined2.default)((0, _removeTypename2.default)(dirtyFormData));
  if (data.loading) {
    return null;
  }

  var resourceName = resource.displayName || resource.name;

  var onSubmit = function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(_ref2) {
      var formData = _ref2.formData;
      var input;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              input = (0, _undefinedToNull2.default)(formData);
              _context.prev = 1;
              _context.next = 4;
              return mutate({ variables: { input: input } });

            case 4:
              history.push('/' + resourceName);
              _reactToastify.toast.success('Update Success');
              _context.next = 11;
              break;

            case 8:
              _context.prev = 8;
              _context.t0 = _context['catch'](1);

              (0, _alertFirstGqlMsg2.default)(_context.t0);

            case 11:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, _this, [[1, 8]]);
    }));

    return function onSubmit(_x) {
      return _ref.apply(this, arguments);
    };
  }();
  var onCancel = function onCancel() {
    history.push('/' + resourceName);
  };
  var updateSchema = (0, _getCRUDSchemaFromResource2.default)({
    config: config,
    resource: resource,
    crudType: 'update'
  });
  return _react2.default.createElement(
    'div',
    null,
    _react2.default.createElement(
      'h1',
      null,
      'Update ',
      (0, _lodash.startCase)(resourceName)
    ),
    _react2.default.createElement(_Form2.default, {
      jsonSchemaFormExtensions: config.jsonSchemaFormExtensions,
      schema: updateSchema.jsonSchema,
      uiSchema: updateSchema.uiSchema,
      formData: purifiedFormData,
      noHtml5Validate: true,
      onSubmit: onSubmit,
      onCancel: onCancel
    })
  );
}

function UpdateWithData(props) {
  var config = props.config,
      resource = props.resource;
  var crudMapping = resource.crudMapping,
      uniqKey = resource.uniqKey;

  var updateSchema = (0, _getCRUDSchemaFromResource2.default)({
    config: config,
    resource: resource,
    crudType: 'update'
  });

  var Component = Update;
  var fieldsQuery = (0, _jsonSchemaToGqlQuery2.default)(updateSchema.jsonSchema);
  var ReadOneQuery = (0, _reactApollo.gql)(_templateObject, crudMapping.readOne, uniqKey, crudMapping.readOne, uniqKey, uniqKey, fieldsQuery);
  var uniqKeyValue = props.match.params[uniqKey];
  Component = (0, _graphqlWithoutCache2.default)(ReadOneQuery, { options: { variables: _defineProperty({}, uniqKey, uniqKeyValue) } })(Component);

  var UpdateQuery = (0, _reactApollo.gql)(_templateObject2, crudMapping.update, (0, _lodash.upperFirst)(updateSchema.inputName || resource.name + 'Input'), crudMapping.update, resource.name, uniqKey, uniqKeyValue);
  Component = (0, _reactApollo.graphql)(UpdateQuery)(Component);

  return _react2.default.createElement(Component, props);
}

exports.default = UpdateWithData;