'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactSelectize = require('react-selectize');

var _lodash = require('lodash');

var _Label = require('./Label');

var _Label2 = _interopRequireDefault(_Label);

var _renderValue2 = require('./renderValue');

var _renderValue3 = _interopRequireDefault(_renderValue2);

var _withOptionItems = require('./withOptionItems');

var _withOptionItems2 = _interopRequireDefault(_withOptionItems);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var MultiSelectWidget = function (_React$Component) {
  _inherits(MultiSelectWidget, _React$Component);

  function MultiSelectWidget() {
    _classCallCheck(this, MultiSelectWidget);

    return _possibleConstructorReturn(this, (MultiSelectWidget.__proto__ || Object.getPrototypeOf(MultiSelectWidget)).apply(this, arguments));
  }

  _createClass(MultiSelectWidget, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          optionItems = _props.optionItems,
          name = _props.name,
          schema = _props.schema,
          uiSchema = _props.uiSchema,
          idSchema = _props.idSchema,
          required = _props.required,
          onChange = _props.onChange,
          formData = _props.formData,
          disabled = _props.disabled,
          readonly = _props.readonly;

      var id = idSchema.$id;
      var lbl = uiSchema['ui:title'] || schema.title || name;
      var valueItems = (formData || []).map(function (item) {
        return optionItems.find(function (opt) {
          return opt.value === item;
        });
      });
      var sortable = uiSchema['ui:options'] && uiSchema['ui:options'].sortable;
      // NOTE: the reason we do this is to fix a bug in react selectize
      // that package caches the renderValue function and it will use the
      // up to date closure data for the function, we use a instance method
      // to bypass this problem
      this.removeByValue = function (value) {
        var nextFormData = formData.filter(function (v) {
          return v !== value;
        });
        onChange(nextFormData);
      };

      this.resortItems = function (values) {
        var valItem = values.map(function (v) {
          return formData.find(function (f) {
            return f === v;
          });
        });
        onChange(valItem);
      };

      this.reorder = function (value, direction) {
        var values = valueItems.map(function (v) {
          return v.value;
        });
        var indx = values.indexOf(value);
        if (direction === '<') {
          values = [].concat(_toConsumableArray(values.slice(0, indx - 1)), [value, values[indx - 1]], _toConsumableArray(values.slice(indx + 1)));
        } else {
          values = [].concat(_toConsumableArray(values.slice(0, indx)), [values[indx + 1], value], _toConsumableArray(values.slice(indx + 2)));
        }
        _this2.resortItems(values);
      };

      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(_Label2.default, { label: lbl, required: required, id: id }),
        _react2.default.createElement(_reactSelectize.MultiSelect, {
          disabled: disabled || readonly,
          values: valueItems.map(function (v, i) {
            return _extends({}, v, { index: i });
          }),
          options: (0, _lodash.sortBy)(optionItems, function (_ref) {
            var label = _ref.label;
            return label.toUpperCase();
          }),
          onValuesChange: function onValuesChange(v) {
            onChange(v.map(function (val) {
              return val.value;
            }));
          },
          renderValue: function renderValue(item) {
            return (0, _renderValue3.default)(item, sortable, valueItems, _this2);
          }
        })
      );
    }
  }]);

  return MultiSelectWidget;
}(_react2.default.Component);

var HasManyField = (0, _withOptionItems2.default)(MultiSelectWidget, 'field');

exports.default = HasManyField;