'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactSelectize = require('react-selectize');

var _withOptionItems = require('./withOptionItems');

var _withOptionItems2 = _interopRequireDefault(_withOptionItems);

var _lodash = require('lodash');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function SimpleSelectWidget(props) {
  var optionItems = props.optionItems;

  var valueItem = optionItems.find(function (option) {
    return option.value === props.value;
  });

  return _react2.default.createElement(_reactSelectize.SimpleSelect, {
    disabled: props.disabled || props.readonly,
    options: (0, _lodash.sortBy)(optionItems, function (_ref) {
      var label = _ref.label;
      return label.toUpperCase();
    }),
    value: valueItem,
    onValueChange: function onValueChange(v) {
      return props.onChange(v && v.value);
    }
  });
}

var HasOneWidget = (0, _withOptionItems2.default)(SimpleSelectWidget, 'widget');

exports.default = HasOneWidget;