'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _formatLabel = require('./formatLabel');

var _formatLabel2 = _interopRequireDefault(_formatLabel);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var REQUIRED_FIELD_SYMBOL = "*";

function Label(props) {
  var label = props.label,
      required = props.required,
      id = props.id;

  if (!label) {
    // See #312: Ensure compatibility with old versions of React.
    return _react2.default.createElement('div', null);
  }
  var formattedLabel = (0, _formatLabel2.default)(label);
  return _react2.default.createElement(
    'label',
    { className: 'control-label', htmlFor: id },
    required ? formattedLabel + REQUIRED_FIELD_SYMBOL : formattedLabel
  );
}

exports.default = Label;