'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _templateObject = _taggedTemplateLiteral(['\n  query TagsAndTagQuestions {\n    tags {\n      _id\n      title\n      tagQuestionId\n    }\n    tagQuestions {\n      _id\n      title\n    }\n  }\n'], ['\n  query TagsAndTagQuestions {\n    tags {\n      _id\n      title\n      tagQuestionId\n    }\n    tagQuestions {\n      _id\n      title\n    }\n  }\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactApollo = require('react-apollo');

var _lodash = require('lodash');

var _reactSelectize = require('react-selectize');

var _Label = require('./Label');

var _Label2 = _interopRequireDefault(_Label);

var _graphqlWithoutCache = require('../../graphqlWithoutCache');

var _graphqlWithoutCache2 = _interopRequireDefault(_graphqlWithoutCache);

var _renderValue2 = require('./renderValue');

var _renderValue3 = _interopRequireDefault(_renderValue2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TagIdsField = function (_React$Component) {
  _inherits(TagIdsField, _React$Component);

  function TagIdsField() {
    _classCallCheck(this, TagIdsField);

    return _possibleConstructorReturn(this, (TagIdsField.__proto__ || Object.getPrototypeOf(TagIdsField)).apply(this, arguments));
  }

  _createClass(TagIdsField, [{
    key: 'removeByValue',

    // NOTE: this is used for MultiSelect
    value: function removeByValue(value) {
      var _props = this.props,
          formData = _props.formData,
          onChange = _props.onChange;

      var nextFormData = formData.filter(function (v) {
        return v !== value;
      });
      onChange(nextFormData);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var props = this.props;
      var name = props.name,
          uiSchema = props.uiSchema,
          idSchema = props.idSchema,
          required = props.required,
          onChange = props.onChange,
          formData = props.formData,
          disabled = props.disabled,
          readonly = props.readonly,
          _props$data = props.data,
          loading = _props$data.loading,
          tags = _props$data.tags,
          tagQuestions = _props$data.tagQuestions;


      if (loading) {
        return null;
      }

      var id = idSchema.$id;
      var label = uiSchema["ui:title"] || name;

      var tagsGroundByQuestions = (0, _lodash.groupBy)(tags, 'tagQuestionId');
      var tagsGroundByQuestionsElements = tagQuestions.map(function (tagQuestion) {
        var optionItems = tagsGroundByQuestions[tagQuestion._id].map(function (t) {
          return {
            value: t._id,
            label: t.title
          };
        });
        var valuesForQuestion = formData.filter(function (tagId) {
          return (0, _lodash.find)(tags, { _id: tagId }).tagQuestionId === tagQuestion._id;
        });
        var valueObjects = optionItems.filter(function (optionItem) {
          return valuesForQuestion.includes(optionItem.value);
        });
        return _react2.default.createElement(
          'div',
          { key: tagQuestion._id },
          _react2.default.createElement(_Label2.default, { label: tagQuestion.title, id: tagQuestion._id }),
          _react2.default.createElement(_reactSelectize.MultiSelect, {
            disabled: disabled || readonly,
            values: valueObjects,
            options: optionItems,
            onValuesChange: function onValuesChange(v) {
              var values = v.map(function (v) {
                return v.value;
              });
              var nextFormData = (0, _lodash.union)((0, _lodash.difference)(formData, valuesForQuestion), values);
              onChange(nextFormData);
            },
            renderValue: function renderValue(item) {
              return (0, _renderValue3.default)(item, _this2);
            }
          })
        );
      });

      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(_Label2.default, { label: label, required: required, id: id }),
        tagsGroundByQuestionsElements
      );
    }
  }]);

  return TagIdsField;
}(_react2.default.Component);

var Query = (0, _reactApollo.gql)(_templateObject);

var TagIdsFieldWithData = (0, _graphqlWithoutCache2.default)(Query)(TagIdsField);
exports.default = TagIdsFieldWithData;