'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodash = require('lodash');

var _reactDraftWysiwyg = require('react-draft-wysiwyg');

var _draftJs = require('draft-js');

var _immutable = require('immutable');

var _draftjsToHtml = require('draftjs-to-html');

var _draftjsToHtml2 = _interopRequireDefault(_draftjsToHtml);

var _draftJsImportHtml = require('draft-js-import-html');

require('react-draft-wysiwyg/dist/react-draft-wysiwyg.css');

var _draftjsUtils = require('draftjs-utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var WysiwygWidget = function (_Component) {
  _inherits(WysiwygWidget, _Component);

  function WysiwygWidget(props) {
    _classCallCheck(this, WysiwygWidget);

    var _this = _possibleConstructorReturn(this, (WysiwygWidget.__proto__ || Object.getPrototypeOf(WysiwygWidget)).call(this, props));

    _initialiseProps.call(_this);

    var value = _this.props.value;

    _this.state = _this.handleState(value, null, false);
    return _this;
  }

  // this method could switch between sync and async based on the updateState argument


  _createClass(WysiwygWidget, [{
    key: 'handleState',
    value: function handleState(newHtml, newEditorState) {
      var updateState = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;

      // we will not have a state at the instance construction, so lets make sure
      // we emulate an empty object for both state and props
      var _ref = this.state || {},
          html = _ref.html,
          editorState = _ref.editorState;

      var _ref2 = this.props || {},
          blockType = _ref2.blockType;

      var state = {};

      // we dont have the html nor the editorState
      if ((0, _lodash.isEmpty)(newHtml) && !newEditorState) {
        state = {
          html: '',
          editorState: (0, _lodash.isEmpty)(blockType) ? _draftJs.EditorState.createEmpty() : _draftJs.EditorState.createWithContent(_draftJs.ContentState.createFromBlockArray([new _draftJs.ContentBlock({
            type: blockType
          })]))
        };

        return updateState ? this.setState(state) : state;
      }

      // we have a new html which is different from the state's html (editor state doesnt matter here)
      if (!(0, _lodash.isEmpty)(newHtml) && newHtml != html) {
        state = {
          html: newHtml,
          editorState: _draftJs.EditorState.createWithContent((0, _draftJsImportHtml.stateFromHTML)(newHtml))
        };

        return updateState ? this.setState(state) : state;
      }

      // we have an updated editorState, lets create the html version from it
      if (newEditorState) {
        state = {
          html: (0, _draftjsToHtml2.default)((0, _draftJs.convertToRaw)(newEditorState.getCurrentContent())),
          editorState: newEditorState
        };

        return updateState ? this.setState(state) : state;
      }

      // do nothing
      return {};
    }

    // lets take advantage of the lifecycle events to manage the state directly (advanced)

  }, {
    key: 'render',
    value: function render() {
      var editorState = this.state.editorState;
      var wysiwygConfig = this.props.options.wysiwygConfig;


      return _react2.default.createElement(_reactDraftWysiwyg.Editor, _extends({
        editorState: editorState,
        onEditorStateChange: this.onEditorStateChange,
        handlePastedText: this.handlePastedText
      }, wysiwygConfig));
    }
  }]);

  return WysiwygWidget;
}(_react.Component);

var _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.componentWillReceiveProps = function (_ref3) {
    var value = _ref3.value;

    _this2.state = _extends({}, _this2.state, _this2.handleState(value, null, false));
  };

  this.handlePastedText = function (text, html) {
    var linesFromText = text.split('\n');

    var editorState = _this2.state.editorState;


    var currentBlockType = (0, _draftjsUtils.getSelectedBlocksType)(editorState);

    var contentBlocksArray = linesFromText.map(function (line) {
      return new _draftJs.ContentBlock({
        key: (0, _draftJs.genKey)(),
        type: currentBlockType,
        characterList: new _immutable.List((0, _immutable.Repeat)(_draftJs.CharacterMetadata.create(), line.length)),
        text: line
      });
    });

    var blockMap = _draftJs.ContentState.createFromBlockArray(contentBlocksArray).blockMap;

    var newState = _draftJs.Modifier.replaceWithFragment(editorState.getCurrentContent(), editorState.getSelection(), blockMap);

    return _this2.handleState(null, _draftJs.EditorState.push(editorState, newState, 'insert-fragment'));
  };

  this.onEditorStateChange = function () {
    var _ref4 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(editorState) {
      var html, onChange;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _this2.handleState(null, editorState);
              html = _this2.state.html;
              onChange = _this2.props.onChange;

              if (!(typeof onChange == 'function')) {
                _context.next = 6;
                break;
              }

              _context.next = 6;
              return onChange(html);

            case 6:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, _this2);
    }));

    return function (_x2) {
      return _ref4.apply(this, arguments);
    };
  }();
};

exports.default = WysiwygWidget;