'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _templateObject = _taggedTemplateLiteral(['\nquery ', 'Query {\n  ', ' {\n    value\n    label\n  }\n}'], ['\nquery ', 'Query {\n  ', ' {\n    value\n    label\n  }\n}']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactApollo = require('react-apollo');

var _lodash = require('lodash');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function withGql(Component) {
  var WithGqlComponent = function (_React$Component) {
    _inherits(WithGqlComponent, _React$Component);

    function WithGqlComponent(props) {
      _classCallCheck(this, WithGqlComponent);

      var _this = _possibleConstructorReturn(this, (WithGqlComponent.__proto__ || Object.getPrototypeOf(WithGqlComponent)).call(this, props));

      _this.state = {
        loading: true,
        optionItems: []
      };
      return _this;
    }

    _createClass(WithGqlComponent, [{
      key: 'componentDidMount',
      value: function componentDidMount() {
        var _this2 = this;

        var _props = this.props,
            gqlOptionsName = _props.gqlOptionsName,
            client = _props.client;


        var query = (0, _reactApollo.gql)(_templateObject, (0, _lodash.upperFirst)(gqlOptionsName), gqlOptionsName);

        client.query({ query: query, fetchPolicy: 'network-only' }).then(function (_ref) {
          var data = _ref.data;

          _this2.setState({
            loading: false,
            optionItems: data[gqlOptionsName]
          });
        }).catch(function (e) {
          throw e;
        });
      }
    }, {
      key: 'render',
      value: function render() {
        if (this.state.loading) {
          return null;
        }
        return _react2.default.createElement(Component, _extends({}, this.props, { optionItems: this.state.optionItems }));
      }
    }]);

    return WithGqlComponent;
  }(_react2.default.Component);

  return WithGqlComponent;
}

function idToGqlOptionsName(id) {
  var name = (0, _lodash.last)(id.split('_'));
  if ((0, _lodash.endsWith)(name, 'Id')) {
    name = name.replace(/Id$/, '');
  } else if ((0, _lodash.endsWith)(name, 'Ids')) {
    name = name.replace(/Ids$/, '');
  }
  return name + 'Options';
}

function withGqlOptionNameForWidget(Component) {
  function WithGqlOptionNameComponent(props) {
    var gqlOptionsName = props.options.gqlOptionsName || idToGqlOptionsName(props.id);
    return _react2.default.createElement(Component, _extends({}, props, { gqlOptionsName: gqlOptionsName }));
  }
  return WithGqlOptionNameComponent;
}

function withGqlOptionNameForField(Component) {
  function WithGqlOptionNameComponent(props) {
    var gqlOptionsName = (0, _lodash.get)(props, 'uiSchema.ui:options.gqlOptionsName') || idToGqlOptionsName(props.name);
    return _react2.default.createElement(Component, _extends({}, props, { gqlOptionsName: gqlOptionsName }));
  }
  return WithGqlOptionNameComponent;
}

var withGqlOptionNameMap = {
  widget: withGqlOptionNameForWidget,
  field: withGqlOptionNameForField
};

function withOptionItems(Component, type) {
  return (0, _lodash.flow)(withGql, withGqlOptionNameMap[type], _reactApollo.withApollo)(Component);
}

exports.default = withOptionItems;