'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
function jsonSchemaToGqlQuery(jsonSchema) {
  var type = jsonSchema.type,
      properties = jsonSchema.properties,
      items = jsonSchema.items;

  switch (type) {
    case 'string':
    case 'number':
    case 'integer':
    case 'boolean':
      return '';
    case 'object':
      var fields = Object.keys(properties).map(function (key) {
        return { key: key, query: jsonSchemaToGqlQuery(properties[key]) };
      }).map(function (_ref) {
        var key = _ref.key,
            query = _ref.query;
        return query ? key + ' ' + query : key;
      }).join('\n');
      return '{\n' + fields + '\n}';
    case 'array':
      var query = jsonSchemaToGqlQuery(items);
      return query;
    default:
      throw new Error('jsonSchemaToGqlQuery unrecognized type: ' + type);
  }
}

exports.default = jsonSchemaToGqlQuery;