'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactApollo = require('react-apollo');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DataFetchingComponent = function (_React$Component) {
  _inherits(DataFetchingComponent, _React$Component);

  function DataFetchingComponent(props) {
    _classCallCheck(this, DataFetchingComponent);

    var _this = _possibleConstructorReturn(this, (DataFetchingComponent.__proto__ || Object.getPrototypeOf(DataFetchingComponent)).call(this, props));

    _this.state = {
      loading: true
    };
    return _this;
  }

  _createClass(DataFetchingComponent, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      var _props = this.props,
          client = _props.client,
          Query = _props.Query,
          queryOptions = _props.queryOptions;

      client.query(_extends({}, queryOptions, { query: Query, fetchPolicy: 'network-only' })).then(function (res) {
        _this2.setState(_extends({
          loading: false
        }, res.data));
      }).catch(function (e) {
        throw e;
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var Component = this.props.Component;

      return _react2.default.createElement(Component, _extends({
        data: this.state
      }, this.props));
    }
  }]);

  return DataFetchingComponent;
}(_react2.default.Component);

function graphqlWithoutCache(Query) {
  var queryOptionsContainer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

  return function (Component) {
    return (0, _reactApollo.withApollo)(function (props) {
      return _react2.default.createElement(DataFetchingComponent, _extends({}, props, {
        Query: Query,
        queryOptions: queryOptionsContainer.options,
        Component: Component
      }));
    });
  };
}

exports.default = graphqlWithoutCache;